Subject: Re: [PATCH iproute2] dcb: app: Add missing "dcb app show dev X default-prio"

From: Stephen Hemminger <[email-masked]>
Date: Wed, 19 Jan 2022 12:35:06 -0800

On Wed, 19 Jan 2022 11:38:54 +0100
Petr Machata <[email-masked]> wrote:

> >
> > In general, we are not allowing more uses of matches(). I think this one
> > can be an exception for consistency with the other options, so really
> > just a heads up.  
> 
> The shortening that the matches() allows is very useful for typing. I do
> stuff like "ip l sh dev X up" and "ip a a dev X 192.0.2.1/28" all the
> time. I suppose there was a discussion about this, can you point me at
> the thread, or where & when approximately it took place so I can look it
> up?

The problem is that matches() doesn't handle conflicts well.
Using your example:
  ip l 
could match "ip link" or "ip l2tp" and the choice of "link" is only because
it was added first. This is bad UI, and creates tribal knowledge that makes
it harder for new users. Other utilities don't allow ambiguous matches.